clc;
clear;

load barbara256.mat
disp('Image loaded')

% Aproximated values for Csvm & sigma
C       = 1000;
sigma   = 4.8;
epsilon = 2.75;
load Epsilon_profile_Gaussian.mat

% Degraded image
Var     = 400;
Idegraded = Im + sqrt(Var)*randn(256);
PP  = perfil_eps*sqrt(Var);
disp(['Image degraded with variance ' num2str(Var)])

% Restore image
tic
disp('Restoring Image ...')
Irestored = restoring_image_SVM(Idegraded,epsilon,C,sigma,PP);
disp('Done!')
toc
% Image equalization on the dinamic range
Rango=[0 255];

Im = (Im-min(Im(:)))/(max(Im(:))-min(Im(:)));
Im = Im*(Rango(2)-Rango(1))+Rango(1);

Irestored = (Irestored-min(Irestored(:)))/(max(Irestored(:))-min(Irestored(:)));
Irestored = Irestored*(Rango(2)-Rango(1))+Rango(1);

% Compute results
RMSE = sqrt(mean((Im(:)-Irestored(:)).^2))
PSNR = psnr(Im,Irestored)

% Show images
figure,imshow(Idegraded/255),title('Degraded Image')
figure,imshow(Irestored/255),title('SVR Restored Image')

