clc;
clear;

load barbara256.mat
disp('Image loaded')

% Aproximated values for Csvm & sigma
C       = 1000;
sigma   = 4.8;
epsilon = 1.25;
load Epsilon_profile_JPEG_Q7.mat

% Degraded image
Quality = 7;
imwrite(Im/255,['./temporal_jpeg.jpg'],'Quality',Quality);
Idegraded = double(imread('temporal_jpeg.jpg'));
delete('./temporal_jpeg.jpg')
disp(['JPEG Image with quality ' num2str(Quality)])

% Restore image 
tic
disp('Restoring Image ...')
Irestored = restoring_image_SVM(Idegraded,epsilon,C,sigma,perfil_eps);
disp('Done!')
toc

% Image equalization on the dinamic range
Rango=[0 255];

Im = (Im-min(Im(:)))/(max(Im(:))-min(Im(:)));
Im = Im*(Rango(2)-Rango(1))+Rango(1);

Irestored = (Irestored-min(Irestored(:)))/(max(Irestored(:))-min(Irestored(:)));
Irestored = Irestored*(Rango(2)-Rango(1))+Rango(1);

% Compute results
RMSE = sqrt(mean((Im(:)-Irestored(:)).^2))
PSNR = psnr(Im,Irestored)

% Show images
figure,imshow(Idegraded/255),title('Degraded Image')
figure,imshow(Irestored/255),title('SVR Restored Image')

