%
% Irestored = restoring_image_SVM(Im,epsilon,Csvm,sigma,perfil_eps)
%
% Notes:
%	- Steerable wavelet transform, 8 orientations, 4 scales
%	- Only works for 256x256 images

function IMM=restoring_image_SVM(Im2,epsilon,Csvm,sigma,perfil_eps)

load C_profile
perfil_sigma=[1 1 1 1];

sigma_2 = sigma;
sigma_1 = sigma_2/2;
AAlfa=linspace(90,-90,9); 

for n=1:8
    Kernel_M(:,:,n) = kernellap2Dsteerable(16,sigma_2,sigma_1,AAlfa(n));
end

perfil_eps_M = perfil_eps*epsilon;
perfil_C_M = perfil_C*Csvm;

ESCALAS=4;
ORIENTACIONES=7;
[pyrR,ind]=buildSFpyr(Im2,ESCALAS,ORIENTACIONES);

L=(1:256)';
UNOS=ones(1,256)';
pyr2=pyrR;
for esc=1:ESCALAS
    for or=1:ORIENTACIONES+1
	fprintf('.')
        BAND_NUM=1+or+(esc-1)*(ORIENTACIONES+1);
        INDD=pyrBandIndices(ind,BAND_NUM);
        
        RES = pyrBand(pyrR, ind, BAND_NUM);
        KB=Kernel_M(:,:,or).^(perfil_sigma(esc));
       
        P_C = perfil_C_M(INDD(1));       
        P_E = perfil_eps_M(INDD(1));
        
        R=blkproc(RES,[16 16],'SVRegression(x,P1,P2,P3,P4,P5)',L,KB,P_C,P_E,UNOS);
        
        pyr2(INDD)=R(:);
       
    end
end
pyr2(1:256*256)=zeros;
IMM=reconSFpyr(pyr2,ind);

fprintf('\n')
